# Multi-modal Example Notebooks

The multi-modal data example uses several notebooks to demonstrate how to use of multi-modal data (text and images)
to provide movie recommendations based on the MovieLens 25M dataset.

* [Training Recommender Systems on Multi-modal Data](00-Intro.ipynb)
* [MovieLens-25M: Download and Convert](01-Download-Convert.ipynb)
* [MovieLens Data Enrichment](02-Data-Enrichment.ipynb)
* [Movie Poster Feature Extraction with ResNet](03-Feature-Extraction-Poster.ipynb)
* [Movie Synopsis Feature Extraction with Bart text summarization](04-Feature-Extraction-Text.ipynb)
* [Creating Multi-Modal Movie Feature Store](05-Create-Feature-Store.ipynb)
* [Feature Engineering with NVTabular](06-ETL-with-NVTabular.ipynb)
* [Training HugeCTR Model with Pre-trained Embeddings](07-Training-with-HugeCTR.ipynb)
